library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;

entity artix_ftdi_test is port(
	CLK: in std_logic;
	D: inout std_logic_vector(7 downto 0);
	RXF: in std_logic;
	TXE: in std_logic;
	RD: out std_logic;
	WR: out std_logic;
	SIWU: out std_logic;
	CLKOUT: in std_logic;
	OE: out std_logic;
	PWRSAV: out std_logic;
	sysled: out std_logic);
end artix_ftdi_test;

architecture behav of artix_ftdi_test is

component clk_wiz_0 port(
	CLKIN : IN  std_logic;
	CLK100 : OUT  std_logic;
	CLK300 : OUT  std_logic);
end component;

signal blinkcounter_60: unsigned(25 downto 0):=(others => '0');
signal CLK300, CLK100: std_logic:='0';
signal rise_60, rise_60_buff0, rise_60_buff1, WR_buff: std_logic:='0';
signal sent: std_logic:='1';
signal send_byte: unsigned(7 downto 0):=(others => '0');

begin

pll1: clk_wiz_0 PORT MAP(
	CLKIN => CLK,
	CLK100 => CLK100,
	CLK300 => CLK300);

RD <= '1';
SIWU <= '1';
OE <= '1';
PWRSAV <= 'Z';

sysled <= blinkcounter_60(25);

process 
	variable sr : std_logic_vector (1 downto 0) := "00";
	begin   
	wait until rising_edge(CLK300);
	sr := sr(0) & CLKOUT;
	rise_60 <= not sr(1) and sr(0);
	rise_60_buff0 <= rise_60;
	rise_60_buff1 <= rise_60_buff0;

	if sr = "01" then
		if sent = '1' then
			D <= std_logic_vector(send_byte);
		end if;
		sent <= '1';
		if TXE = '0' then
			WR <= '0';
			WR_buff <= '0';
		else
			WR <= '1';
			WR_buff <= '1';
		end if;
	end if;
	
	if rise_60 = '1' then
		sent <= not TXE;
	end if;
	
	if rise_60_buff0 = '1' then
		sent <= not TXE;
	end if;
	
	if rise_60_buff1 = '1' then
		if TXE = '0' and sent = '1' and WR_buff = '0' then
			send_byte <= send_byte +1;
		end if;
	end if;
	
	if sr = "01" then
		blinkcounter_60 <= blinkcounter_60 +1;
	end if;
end process;

end behav;